#include <stdio.h>
#include <string.h>
#include <mpi.h>

int main(int argc, char * argv[])
{
  int myProcessNo;
  int numProcesses;
  char message[256];
  int srcProcessNo = 0;

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &myProcessNo);
  MPI_Comm_size(MPI_COMM_WORLD, &numProcesses);
   
  if (myProcessNo == 0)
  {
    /* Proces wysylajacy komunikat "Hello world..." */
    int messageLen = snprintf(
        message,
        sizeof(message) / sizeof(char),
        "Hello world from process %d!",
        myProcessNo
    ) + 1;
    if (messageLen > sizeof(message) / sizeof(char))
    {
      messageLen = sizeof(message) / sizeof(char);
    }
    MPI_Bcast(
        message,
        messageLen,
        MPI_CHAR,
        srcProcessNo,
        MPI_COMM_WORLD
    );
  }
  else
  {
    /* Proces odbierajacy komunikaty "Hello world..." */
    MPI_Bcast(
        message,
        sizeof(message) / sizeof(char),
        MPI_CHAR,
        srcProcessNo,
        MPI_COMM_WORLD
    );
    printf("Process %d received broadcast message \"%s\"\n", myProcessNo, message);
  }

  MPI_Finalize();

  return 0;
}
