#include <stdio.h>
#include <string.h>
#include <mpi.h>

static int const MPI_MESSAGE_HELLO_WORLD_TAG = 50;

int main(int argc, char * argv[])
{
  int myProcessNo;
  int numProcesses;
  char message[256];

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &myProcessNo);
  MPI_Comm_size(MPI_COMM_WORLD, &numProcesses);
   
  if (myProcessNo != 0)
  {
    /* Proces wysylajacy komunikat "Hello world..." */
    int dstProcessNo = 0;
    int messageLen = snprintf(
        message,
        sizeof(message) / sizeof(char),
        "Hello world from process %d!",
        myProcessNo
    ) + 1;
    if (messageLen > sizeof(message) / sizeof(char))
    {
      messageLen = sizeof(message) / sizeof(char);
    }
    MPI_Send(
        message,
        messageLen,
        MPI_CHAR,
        dstProcessNo,
        MPI_MESSAGE_HELLO_WORLD_TAG,
        MPI_COMM_WORLD
    );
  }
  else
  {
    /* Proces odbierajacy komunikaty "Hello world..." */
    MPI_Status status;
    int srcProcessNo;
    printf("A parallel MPI-based \"Hello world!\" application.\n");
    for (srcProcessNo = 1; srcProcessNo < numProcesses; ++srcProcessNo)
    {
      MPI_Recv(
          message,
          sizeof(message) / sizeof(char),
          MPI_CHAR,
          srcProcessNo,
          MPI_MESSAGE_HELLO_WORLD_TAG,
          MPI_COMM_WORLD,
          &status
      );
      printf("%s\n", message);
    }
  }

  MPI_Finalize();

  return 0;
}
